'LOADING DATA
'*******************************************************
'Loading data and transforming Excel file -> Panel
wfopen dat_imf&conf_database.xls range="Panel"

'STRUCTURING THE DATABASE
'*******************************************************
pagestruct country @date(dateid)
'Assigning name to the sheet 
pagerename untitled Panel
'Transforming Panel->Time series
genr d_oecd_lmr=oecd_lmr-oecd_lmr(-1)
series oecd_lmr_ind=(d_oecd_lmr<0)
pageunstack country dateid
'Assigning name to the sheet
pagerename untitled TimeSeries
'***********************************************************
' EPISODES: SUCCESSFUL AND UNSUCCESSFUL
'***********************************************************
PAGESELECT TIMESERIES 
SMPL 1981 2007  

FOR %IDC AUS AUT BEL CAN DEU DNK ESP FIN FRA GBR IRL ITA JPN NLD PRT SWE USA
		SMPL 1970 2007

		'  *  ADDITIONAL VARIABLES  *			
		'***************************************************************************
	 	GENR ds_t{%IDC}=r_sh{%IDC}-r_sh{%IDC}(-1)
           GENR Y_{%IDC}=100*LOG(GDPV{%IDC})
		GENR L_ESI_con{%IDC}=100*LOG(ESI_con{%IDC})
		GENR L_ESI_ind{%IDC}=100*LOG(ESI_ind{%IDC})
           GENR DLT_Y_{%IDC}=Y_{%IDC}-Y_{%IDC}(-1)
		GENR P_GDP_{%IDC}= GDP{%IDC}/GDPV{%IDC}
		GENR INFL_{%IDC}=100*LOG(P_GDP_{%IDC}/P_GDP_{%IDC}(-1))
           'GENR D_OECD_LMR{%IDC}=OECD_LMR{%IDC}-OECD_LMR{%IDC}(-1)
		 HPF   Y_{%IDC}  Y_{%IDC}_HP
		GENR CYCLE{%IDC}=   Y_{%IDC}- Y_{%IDC}_HP
		SERIES  CYCLE_up{%IDC}=0
		SERIES  CYCLE_dwn{%IDC}=0	
		CYCLE_up{%IDC}=(CYCLE{%IDC}>0)
		CYCLE_dwn{%IDC}=(CYCLE{%IDC}<0)
		GENR cycle1{%IDC}=exp(-0.015*0.5*(DLT_Y_{%IDC}+DLT_Y_{%IDC}(-1)))/(1+exp(-0.015*0.5*(DLT_Y_{%IDC}+DLT_Y_{%IDC}(-1))))

		GENR IMF_TOT_UT{%IDC}=IMF_TAX_UT{%IDC} + IMF_SPND_UT{%IDC}
		GENR IMF_TOT_ATT{%IDC}=IMF_TAX_ATT{%IDC} + IMF_SPND_ATT{%IDC}
		GENR IMF_TOT_ATT1{%IDC}=IMF_TAX_ATT1{%IDC} + IMF_SPND_ATT1{%IDC}
		GENR IMF_TOT_ATT2{%IDC}=IMF_TAX_ATT2{%IDC} + IMF_SPND_ATT2{%IDC}
		GENR IMF_TOT_ATT3{%IDC}=IMF_TAX_ATT3{%IDC} + IMF_SPND_ATT3{%IDC}
		GENR IMF_TOT_ATT4{%IDC}=IMF_TAX_ATT4{%IDC} + IMF_SPND_ATT4{%IDC}
		GENR IMF_TOT_ATT5{%IDC}=IMF_TAX_ATT5{%IDC} + IMF_SPND_ATT5{%IDC}

		GENR SPREAD{%IDC} = R_LO{%IDC} - R_SH{%IDC}
		GENR Y_PC{%IDC} = DLT_Y_{%IDC}-100*LOG(POPT{%IDC}/POPT{%IDC}(-1))	

		GENR L_PFCE{%IDC} = 100*LOG(PFCE{%IDC}*1000000)
		GENR L_GFCF{%IDC} = 100*LOG(GFCF{%IDC}*1000000)
		GENR DLT_PFCE{%IDC} = L_PFCE{%IDC}-L_PFCE{%IDC}(-1)
		GENR DLT_GFCF{%IDC} = L_GFCF{%IDC}-L_GFCF{%IDC}(-1)
		GENR PFCE_PC{%IDC} = DLT_PFCE{%IDC}-100*LOG(POPT{%IDC}/POPT{%IDC}(-1))
		GENR GFCF_PC{%IDC} = DLT_GFCF{%IDC}-100*LOG(POPT{%IDC}/POPT{%IDC}(-1))
		'GENR DLT_PROF{%IDC} = ((PROFIT{%IDC}-PROFIT{%IDC}(-1))/PROFIT{%IDC}(-1))

	'Generating of a new series using the OECD data for CONS, INV, NE
		GENR L_CPV{%IDC} = 100*LOG(CPV{%IDC})
		GENR L_IPV{%IDC} = 100*LOG(IPV{%IDC})   
		GENR L_ITV{%IDC} = 100*LOG(ITV{%IDC})  
		GENR DLT_CPV{%IDC} = L_CPV{%IDC}-L_CPV{%IDC}(-1)
		GENR DLT_IPV{%IDC} = L_IPV{%IDC}-L_IPV{%IDC}(-1)
		GENR DLT_ITV{%IDC} = L_ITV{%IDC}-L_ITV{%IDC}(-1)
		GENR CPV_PC{%IDC} = DLT_CPV{%IDC}-100*LOG(POPT{%IDC}/POPT{%IDC}(-1))
		GENR IPV_PC{%IDC} = DLT_IPV{%IDC}-100*LOG(POPT{%IDC}/POPT{%IDC}(-1))
		GENR ITV_PC{%IDC} = DLT_ITV{%IDC}-100*LOG(POPT{%IDC}/POPT{%IDC}(-1))
		GENR DT_NE{%IDC} = (NE{%IDC}-NE{%IDC}(-1))
		GENR DT_NEY{%IDC}=100*DT_NE{%IDC} /GDPV{%IDC}
		'GENR NE_PC{%IDC} = DLT_NE{%IDC}-(POPT{%IDC}-POPT{%IDC}(-1))/POPT{%IDC}(-1)
		GENR DLT_CPV1{%IDC} = (CPV{%IDC}-CPV{%IDC}(-1))/CPV{%IDC}(-1)  
		GENR CPV1_PC{%IDC} = 100*(DLT_CPV1{%IDC}-(POPT{%IDC}-POPT{%IDC}(-1))/POPT{%IDC}(-1))
		IF %IDC = "ESP" OR  %IDC = "ITA" THEN 
				GENR ipv_mix{%IDC} = itv_pc{%IDC}
				else GENR ipv_mix{%IDC} = ipv_pc{%IDC}
		ENDIF

		'Activate for Alesina-Ardagna:
		 'GENR DEBTG{%IDC}=GGFL{%IDC}/GDPTR{%IDC}
            'GENR DLT_DEBTG{%IDC}=DEBTG{%IDC}-DEBTG{%IDC}(-1)
		 'GENR AA_TOT_{%IDC}=100*AA{%IDC}
	   	 'DELETE AA{%IDC}		

'   *  IMF: SUCCESSFUL AND UNSUCCESSFUL TIGHT EPISODES  *
		'***************************************************************************
		'SMPL 1980 2005
		'SERIES C_DLT_DEBTG_I{%IDC}=0
		'SERIES IMF{%IDC}=0
		'SERIES SUCIMF{%IDC}=0
		'SERIES NOSUCIMF{%IDC}=0
		'SERIES NOACTIMF{%IDC}=0
		'SMPL 1980 2005
		'FOR !i=1 TO 36 
		'	IF DLT_DEBTG{%IDC}(!i+1)+DLT_DEBTG{%IDC}(!i+2)<>NA THEN
		'		IF IMF_TOT{%IDC}(!i)<>0 THEN
	      '			C_DLT_DEBTG_I{%IDC}(!i)=DLT_DEBTG{%IDC}(!i+1)+DLT_DEBTG{%IDC}(!i+2)
		'			'Watch out with the percentile!!!
		'			IF C_DLT_DEBTG_I{%IDC}(!i)<-0.0358 THEN
		'				SUCIMF{%IDC}(!i)=1
		'			ELSE
		'				NOSUCIMF{%IDC}(!i)=1
		'			ENDIF
		'			IMF{%IDC}=SUCIMF{%IDC}+NOSUCIMF{%IDC}
		'		ELSE
		'			NOACTIMF{%IDC}(!i)=1
		'		ENDIF
		'	ELSE
		'		C_DLT_DEBTG_I{%IDC}(!i)=NA
		'		SUCIMF{%IDC}(!i)=NA
		'		NOSUCIMF{%IDC}(!i)=NA
		'		NOACTIMF{%IDC}(!i)=NA
		'		IMF{%IDC}=NA
		'	ENDIF
		'NEXT

NEXT

'  *  TAX BASED AND EXP BASED EPISODES   *
'***********************************************************
PAGESELECT TIMESERIES 

FOR %IDC AUS AUT BEL CAN DEU DNK ESP FIN FRA GBR IRL ITA JPN NLD PRT SWE USA
		SMPL 1970 2007
		' * DUMMY INCLUDING:   UNANTICIPATED AND ANTICIPATED *
		'********************************************************************
		GENR TAX_SHOCK{%IDC} = IMF_TAX_UT{%IDC} + IMF_TAX_att{%IDC} + IMF_TAX_att1{%IDC} + IMF_TAX_att2{%IDC} + IMF_TAX_att3{%IDC} + IMF_TAX_att4{%IDC} + IMF_TAX_att5{%IDC}
		GENR SPND_SHOCK{%IDC} = IMF_SPND_UT{%IDC} + IMF_SPND_att{%IDC} + IMF_SPND_att1{%IDC} + IMF_SPND_att2{%IDC} + IMF_SPND_att3{%IDC} + IMF_SPND_att4{%IDC} + IMF_SPND_att5{%IDC}
		GENR TOT_SHOCK{%IDC} = TAX_SHOCK{%IDC} + SPND_SHOCK{%IDC}

		'SERIES IMF_TB{%IDC}=0
		'SERIES IMF_EB{%IDC}=0
		'SERIES IMF_DUM_a{%IDC}=0
		'IMF_EB_a{%IDC}=((SPND_SHOCK{%IDC}/(TOT_SHOCK{%IDC}+0.01))>0.5)
		'IMF_DUM_a{%IDC}=(abs(TOT_SHOCK{%IDC})>0)
		'IMF_TB_a{%IDC}=IMF_DUM_a{%IDC}-IMF_EB_a{%IDC}

		' * DUMMY INCLUDING:   UNANTICIPATED *
		'********************************************************************
		SERIES IMF_DUM1{%IDC}=0
		SERIES IMF_TB1{%IDC}=0
		SERIES IMF_EB1{%IDC}=0
		IMF_EB1{%IDC}=((IMF_SPND{%IDC}/(IMF_TOT{%IDC}+0.01))>0.5)
		IMF_DUM1{%IDC}=(abs(IMF_TOT{%IDC})>0)
		IMF_TB1{%IDC}=IMF_DUM1{%IDC}-IMF_EB1{%IDC}
NEXT

PAGESELECT TIMESERIES 
PAGESTRUCT(end=@last+13) *
PAGESTACK(page=stackctry)  GDPV?
PAGESELECT TIMESERIES

'create time dummies
smpl @all
FOR %IDC 1981 1982 1983 1984 1985 1986 1987 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011 2012 2013   '1980 
smpl @all
GENR DUMMY_{%IDC}=0
smpl %IDC %IDC
dummy_{%IDC}=1
next

smpl @first 1998 
series dum_euro=0
smpl 1999 @last 
series dum_euro=1
smpl @all

